import os, sys
import coral
import cherrypy
from optparse import OptionParser
import DLFCN
sys.setdlopenflags(DLFCN.RTLD_GLOBAL+DLFCN.RTLD_LAZY)
from Applications import iovInspect,iovInspectOld,iovExport,globaltag,serviceMap,luminosityApp
from Common import config
#from pluginCondDBPyInterface import *
os.environ["QUIET_ASSERT"]='yes'
class Root(object):
    @cherrypy.expose
    def index(self):
        """ Top level page
        """
        return "This is Cond DB Application Server"

class Server(object):
    def __init__(self):
        self.__hostname='localhost'
        self.__port=6789
        self.__oldappconfigfile='oldapplication.conf'
        self.__appconfigfile='application.conf'
        self.__detconfigfile='detector31x.conf'
        self.__olddetconfigfile='detector.conf'
    def start (self):
        """Start server
        """
        parser=OptionParser()
        parser.add_option("--port",action="store",dest="port",
                          help="port default 6789")       
        parser.add_option("--hostname",action="store",dest="hostname",
                          help="hostname default localhost")       
        parser.add_option("--configdir",action="store",dest="configdir",
                          help="configuration dir. Default to currentdir/config")
        (options, args) = parser.parse_args()
        if options.hostname:
            self.__hostname=options.hostname.strip(' ')
        if options.port:
            self.__port=int(options.port)
	if options.configdir:
	    self.__configdir = options.configdir.strip(' ')
        else:
            currentdir=os.path.dirname(os.path.abspath(__file__))
            self.__configdir = os.path.join(currentdir,'config')
        serverconfig={'global':{'server.socket_host':self.__hostname,'server.socket_port':self.__port,'server.environment':'production'}}
        cherrypy.config.update(serverconfig)
        cherrypy.tree.mount(Root(),script_name='/')

        # here for the time being
        self.__config=config.Config()
        self.__config.from_ini(os.path.join(self.__configdir,self.__appconfigfile))
        cherrypy.tree.mount(iovInspect.IOV(os.path.join(self.__configdir,self.__appconfigfile)),script_name='/iov')
        cherrypy.tree.mount(iovInspectOld.IOV(os.path.join(self.__configdir,self.__appconfigfile)),script_name='/oldiov')
        cherrypy.tree.mount(iovExport.IOV(os.path.join(self.__configdir,self.__appconfigfile)),script_name='/exportIov')
        cherrypy.tree.mount(serviceMap.serviceMap(os.path.join(self.__configdir,self.__detconfigfile)),script_name='/serviceMap')
        cherrypy.tree.mount(serviceMap.serviceMap(os.path.join(self.__configdir,self.__olddetconfigfile)),script_name='/oldserviceMap')
        cherrypy.tree.mount(globaltag.GlobalTag(os.path.join(self.__configdir,self.__appconfigfile)),script_name='/globaltag')
        cherrypy.tree.mount(luminosityApp.lumi(os.path.join(self.__configdir,self.__appconfigfile)),script_name='/lumi')
        cherrypy.server.quickstart()
        cherrypy.engine.start()

if __name__ == '__main__':
    fileHandle=open('pid.txt','w')
    fileHandle.seek(0)
    mypid=os.getpid()
    fileHandle.write( str(mypid) )
    fileHandle.close()
    s=Server()
    s.start()

